<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher"
        />
      </div>
      <div class="col-xs-12 col-md-6">
        <click-button
          @click="clearFilter"
        >
          <template #content>
            Effacer tous les filtres
          </template>
        </click-button>
        <!--        <el-button @click="toggleSelection()">-->
        <!--          Effacer la sélection-->
        <!--        </el-button>-->
      </div>
    </div>
    <div class="row">
      <el-table
        ref="businessesTable"
        :data="pagedAndFilteredBusinesses"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @sort-change="customSort"
        @selection-change="handleSelectionChange"
      >
        <!--        <el-table-column-->
        <!--          type="selection"-->
        <!--          width="55"-->
        <!--        />-->
        <el-table-column
          prop="createdAt"
          label="Inscrit le"
          sortable="custom"
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDate }}
          </template>
        </el-table-column>
        <el-table-column
          prop="email"
          label="Email"
          sortable
        />
        <el-table-column
          prop="id"
          label="Sirens"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.sirens.length > 3">
              <el-button
                type="text"
                @click="seeMoreSirens(scope.row.sirens)"
              >
                Voir les {{ scope.row.sirens.length }} éléments
              </el-button>
            </p>
            <p
              v-for="(siren, sirenIndex) in scope.row.sirens"
              v-else
              :key="siren.id"
            >
              {{ scope.row.sirens[sirenIndex].number }}
            </p>
          </template>
        </el-table-column>
        <el-table-column
          prop="id"
          label="Équipe(s)"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.teams.length > 3">
              <el-button
                type="text"
                @click="seeMoreTeams(scope.row.teams)"
              >
                Voir les {{ scope.row.teams.length }} éléments
              </el-button>
            </p>
            <p
              v-for="(team, teamIndex) in scope.row.teams"
              v-else
              :key="team.id"
            >
              {{ scope.row.teams[teamIndex].description }}
            </p>
          </template>
        </el-table-column>
        <el-table-column
          prop="uuid"
          label="UUID"
          sortable
        />
        <el-table-column
          prop="isFrozen"
          label="Compte gelé"
          sortable
        >
          <template slot-scope="scope">
            {{ scope.row.isFrozen | yesNoText }}
          </template>
        </el-table-column>
        <el-table-column
          prop="isValidPayment"
          label="Paiement"
          sortable
        >
          <template slot-scope="scope">
            <click-button
              v-if="scope.row.isValidPayment===false"
              :disabled="false"
              @click="performValidBusinessPayment(scope.row)"
            >
              <template #content>
                Valider
                <valid-icon />
              </template>
            </click-button>
            <click-button
              v-else
              :disabled="isLoading"
              @click="performInvalidBusinessPayment(scope.row)"
            >
              <template #content>
                Annuler
                <remove-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
        <el-table-column
          prop="isActive"
          label="Accès à la plateforme"
          sortable
        >
          <template slot-scope="scope">
            <click-button
              v-if="scope.row.isActive===true"
              :disabled="isLoading"
              @click="performLockBusiness(scope.row)"
            >
              <template #content>
                Bloquer
                <lock-icon />
              </template>
            </click-button>
            <click-button
              v-else
              :disabled="isLoading"
              @click="performUnlockBusiness(scope.row)"
            >
              <template #content>
                Débloquer
                <unlock-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
        <el-table-column
          prop="connect"
          label="Se connecter"
        >
          <template slot-scope="scope">
            <click-button
              :disabled="isLoading"
              @click="impersonate(scope.row.email)"
            >
              <template #content>
                <ghost-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredBusinesses.length"
        @current-change="handleCurrentChange"
      />
    </div>
  </div>
</template>

<script>
import UnlockIcon from "../../../components/Icon/UnlockIcon";
import LockIcon from "../../../components/Icon/LockIcon";
import ValidIcon from "../../../components/Icon/ValidIcon";
import RemoveIcon from "../../../components/Icon/RemoveIcon";
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";
import GhostIcon from "../../../components/Icon/GhostIcon";
import ClickButton from "../../../components/Button/ClickButton";

export default {
  name: "AdminBusinessTable",
  components: {ClickButton, GhostIcon, UnlockIcon, LockIcon, ValidIcon, RemoveIcon},
  data() {
    return {
      search: '',
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10
    }
  },
  computed: {
    pagedAndFilteredBusinesses() {
      return !this.search
        ?
        this.businesses.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.businesses.filter(business => business.email.toLowerCase().includes(this.search.toLowerCase())).slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)

    },
    filteredBusinesses() {
      return this.search ? this.businesses.filter(business => business.email.toLowerCase().includes(this.search.toLowerCase())) : this.businesses
    },
    ...mapGetters([
      'isLoading',
      'businesses'
    ])
  },
  methods: {
    ...mapActions([
      'lockBusiness',
      'unlockBusiness',
      'validBusinessPayment',
      'invalidBusinessPayment',
      'loadingStarts',
      'loadingEnds',
      'impersonate'
    ]),
    customSort(column) {
      console.log(column)
    },
    handleCurrentChange(val) {
      this.currentPage = val
    },
    // toggleSelection(rows) {
    //   if (rows) {
    //     rows.forEach(row => {
    //       this.$refs.businessesTable.toggleRowSelection(row);
    //     });
    //   } else {
    //     this.$refs.businessesTable.clearSelection();
    //   }
    // },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    clearFilter() {
      this.$refs.businessesTable.clearFilter();
    },
    performLockBusiness(business) {
      this.loadingStarts()
      this.lockBusiness(business).then(()=>{
        VanillaToasts.create({
          title: 'Gestion domaines',
          text: 'Domaine verrouillé avec succès',
          type: 'success',
          timeout: 5000,
        });
        this.loadingEnds()
      })
    },
    performUnlockBusiness(business) {
      this.loadingStarts()
      this.unlockBusiness(business).then(()=>{
        VanillaToasts.create({
          title: 'Gestion domaine',
          text: 'Domaine déverrouillé avec succès',
          type: 'success',
          timeout: 5000,
        });
        this.loadingEnds()
      })
    },
    performValidBusinessPayment(business) {
      this.loadingStarts()
      this.validBusinessPayment(business).then(()=>{
        VanillaToasts.create({
          title: 'Gestion domaine',
          text: 'Paiement domaine validé avec succès',
          type: 'success',
          timeout: 5000,
        });
        this.loadingEnds()
      })
    },
    performInvalidBusinessPayment(business) {
      this.loadingStarts()
      this.invalidBusinessPayment(business).then(()=>{
        VanillaToasts.create({
          title: 'Gestion domaine',
          text: 'Paiement domaine invalidé',
          type: 'success',
          timeout: 5000,
        });
        this.loadingEnds()
      })
    },
    seeMoreSirens(sirens) {
      let text = ''
      sirens.forEach(siren => {
        text+= siren.number+', '
      });
      text = text.substring(0, text.length-2)
      this.$alert(text, 'Liste des sirens', {
        confirmButtonText: 'Retour'
      });
    },
    seeMoreTeams(teams) {
      let text = ''
      teams.forEach(team => {
        text+= team.description+', '
      });
      text = text.substring(0, text.length-2)
      this.$alert(text, 'Liste des équipes', {
        confirmButtonText: 'Retour'
      });
    }
  }
}
</script>

<style scoped>
  .row {
    margin-top: 2vh;
  }
</style>